gtkmm: Gtk::BoolFilter Class Reference

gtkmm 4.4.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::BoolFilter Class Reference

Filtering by boolean expressions. More...

`#include <gtkmm/boolfilter.h>`

Inheritance diagram for Gtk::BoolFilter:
[legend]

## Public Member Functions
| BoolFilter (BoolFilter && src) noexcept
BoolFilter & | operator= (BoolFilter && src) noexcept
| ~BoolFilter () noexcept override
GtkBoolFilter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBoolFilter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkBoolFilter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Expression< bool > > | get_expression ()
| Gets the expression that the filter uses to evaluate if an item should be filtered. More...
Glib::RefPtr< const Expression< bool > > | get_expression () const
| Gets the expression that the filter uses to evaluate if an item should be filtered. More...
void | set_expression (const Glib::RefPtr< Expression< bool >> & expression)
| Sets the expression that the filter uses to check if items should be filtered. More...
bool | get_invert () const
| Returns whether the filter inverts the expression. More...
void | set_invert (bool invert=true)
| Sets whether the filter should invert the expression. More...
Glib::PropertyProxy< Glib::RefPtr< Expression< bool > > > | property_expression ()
| The boolean expression to evaluate on item. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Expression< bool > > > | property_expression () const
| The boolean expression to evaluate on item. More...
Glib::PropertyProxy< bool > | property_invert ()
| If the expression result should be inverted. More...
Glib::PropertyProxy_ReadOnly< bool > | property_invert () const
| If the expression result should be inverted. More...
Public Member Functions inherited from Gtk::Filter
| Filter (Filter && src) noexcept
Filter & | operator= (Filter && src) noexcept
| ~Filter () noexcept override
GtkFilter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkFilter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkFilter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | match (const Glib::RefPtr< Glib::ObjectBase > & item)
| Checks if the given item is matched by the filter or not. More...
Match | get_strictness ()
| Gets the known strictness of filters. More...
Glib::SignalProxy< void(Change)> | signal_changed ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< BoolFilter > | create (const Glib::RefPtr< Expression< bool >> & expression)
Static Public Member Functions inherited from Gtk::Filter
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| BoolFilter (const Glib::RefPtr< Expression< bool >> & expression)
Protected Member Functions inherited from Gtk::Filter
| Filter ()
void | changed (Change change=Change::DIFFERENT)
| Notifies all users of the filter that it has changed. More...
virtual bool | match_vfunc (const Glib::RefPtr< Glib::ObjectBase > & item)
virtual Match | get_strictness_vfunc ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::BoolFilter > | wrap (GtkBoolFilter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Filter
Glib::RefPtr< Gtk::Filter > | wrap (GtkFilter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Filter
enum | Match { Match::SOME, Match::NONE, Match::ALL }
| Describes the known strictness of a filter. More...
enum | Change { Change::DIFFERENT, Change::LESS_STRICT, Change::MORE_STRICT }
| Describes changes in a filter in more detail and allows objects using the filter to optimize refiltering items. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Filtering by boolean expressions.

Gtk::BoolFilter is a simple filter that takes a boolean Gtk::Expression to determine whether to include items.

Since gtkmm 3.98:

## Constructor & Destructor Documentation

Gtk::BoolFilter::BoolFilter | ( | BoolFilter && | src | ) |
| noexcept

Gtk::BoolFilter::~BoolFilter | ( |  | ) |
| overridenoexcept

Gtk::BoolFilter::BoolFilter | ( | const Glib::RefPtr< Expression< bool >> & | expression | ) |
| explicitprotected

## Member Function Documentation

static Glib::RefPtr<BoolFilter> Gtk::BoolFilter::create | ( | const Glib::RefPtr< Expression< bool >> & | expression | ) |
| static

Glib::RefPtr<Expression<bool> > Gtk::BoolFilter::get_expression | ( |  | ) |

Gets the expression that the filter uses to evaluate if an item should be filtered.

Returns
  A `Gtk::Expression`.

Glib::RefPtr<const Expression<bool> > Gtk::BoolFilter::get_expression | ( |  | ) | const

Gets the expression that the filter uses to evaluate if an item should be filtered.

Returns
  A `Gtk::Expression`.

bool Gtk::BoolFilter::get_invert | ( |  | ) | const

Returns whether the filter inverts the expression.

Returns
  `true` if the filter inverts.

static GType Gtk::BoolFilter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkBoolFilter* Gtk::BoolFilter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkBoolFilter* Gtk::BoolFilter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkBoolFilter* Gtk::BoolFilter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

BoolFilter& Gtk::BoolFilter::operator= | ( | BoolFilter && | src | ) |
| noexcept

Glib::PropertyProxy< Glib::RefPtr<Expression<bool> > > Gtk::BoolFilter::property_expression | ( |  | ) |

The boolean expression to evaluate on item.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Expression<bool> > > Gtk::BoolFilter::property_expression | ( |  | ) | const

The boolean expression to evaluate on item.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::BoolFilter::property_invert | ( |  | ) |

If the expression result should be inverted.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::BoolFilter::property_invert | ( |  | ) | const

If the expression result should be inverted.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::BoolFilter::set_expression | ( | const Glib::RefPtr< Expression< bool >> & | expression | ) |

Sets the expression that the filter uses to check if items should be filtered.

The expression must have a value type of G_TYPE_BOOLEAN.

Parameters

  expression | A `Gtk::Expression`.

void Gtk::BoolFilter::set_invert | ( | bool | invert = `true` | ) |

Sets whether the filter should invert the expression.

Parameters

  invert | `true` to invert.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::BoolFilter > wrap | ( | GtkBoolFilter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.